var pi_Styles = {
	
	// Stylesheet services
	_sss: Components.classes["@mozilla.org/content/style-sheet-service;1"]
												.getService(Components.interfaces.nsIStyleSheetService),
	_ios: Components.classes["@mozilla.org/network/io-service;1"]
												.getService(Components.interfaces.nsIIOService),
												
	/**
	 * Initialization
	 *
	 */
	init: function init() {
	
		// Stylesheet setup
		var uri = this._ios.newURI("chrome://pi/content/pi.css", null, null);
		if(!this._sss.sheetRegistered(uri, this._sss.USER_SHEET))
				this._sss.loadAndRegisterSheet(uri, this._sss.USER_SHEET);		
	}
};

var pi_Logger = {

	// Set debug level (true, false)
	_debug: true,

	// Console service
	_consoleService: Components.classes['@mozilla.org/consoleservice;1']
	.getService(Components.interfaces.nsIConsoleService),
	
	
		/**
	 * Send debug message to console.
	 * 
	 * @param message
	 */	
	log: function log(msg) {
		var myCaller = this.log.caller.name;
		
		this._consoleService.logStringMessage(
			'Pisexier:'+ myCaller +': ' + msg);
	}
};

var pi_Prefs = {
	
	// Grab prefs
	_prefs: Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefBranch),
	
	/**
	 * Get preference value.
	 * 
	 * @param aPrefName
	 */
	getPref: function getPref(aPrefName) {
		try {
			var prefType = this._prefs.getPrefType(aPrefName), value;
	
			switch (prefType) {
				case this._prefs.PREF_BOOL:
					value = this._prefs.getBoolPref(aPrefName);
					break;
				case this._prefs.PREF_INT:
					value = this._prefs.getIntPref(aPrefName);
					break;
				case this._prefs.PREF_STRING:
					value = this._prefs.getCharPref(aPrefName);
					break;
				default:
					pi_Logger.log('Unsupported type for '+ aPrefName +': '+ prefType);
			}
		}
		catch (err) {
			pi_Logger.log('You entered the catch block');
		
			value = aDefaultValue;
			return value;
		}
		
		return value;
	}
};